/*
STM.h Written by Walter O. Krawec
Header file for the abstract class STM (Short Term Memory)
If you decide to design your own STM (instead of U Learning or EL Learning)
You should derive from this class else you will have to rewrite portions of ENN.h/cpp

Copyright (c) 2012 Walter O. Krawec

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/

#ifndef MTENN_STM_H_
#define MTENN_STM_H_

#include <vector>

namespace MTENN
{
	class ENN;

	class STM
	{
	public:
		virtual bool setup(int numInputs, int numOutputs)=0;
		virtual float fitness(ENN* network)=0;
		virtual float maxFitness()=0;
		virtual float minFitness()=0;
		virtual void mainLoop(){};

		virtual bool resize(int numInputs, int numOutputs)=0;
		virtual void addToMemory(const std::vector <float>& inputs, const std::vector <float>& outputs, float reward)=0;
		virtual void degrade(float scalar)=0;
	};
}

#endif