/*
main.h Written by Walter O. Krawec
Demonstration of software described in the article

Copyright (c) 2012 Walter O. Krawec

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

// See "simulation.h" and "ENN/ENNInterface.h" for more info

#include <iostream>
#include <conio.h>

#define MTENN_DEBUG

#include "simulation.h"

int main(int argc, char* argv)
{
	srand(time(NULL));
	wok::sockets::Socket s;
	s.initWinSock();
	if(!connectToSRS10("127.0.0.1"))
		return 0;

	setupRobot();

	while(1)
	{
		if(_kbhit())
		{
			char c = getch();
			if(c == 'q')
				break;
			else if(c == 'e')
			{
				std::cout << "\nNetwork will now evolve...\n";
				ai.setPauseEvolve(false);
			}
			else if(c == 'r')
			{
				std::cout << "\nNetwork will stop evolving (STM still running)...\n";
				ai.setPauseEvolve(true);
			}
			else if(c == 'd')
			{
				std::cout << "\nDEBUG INFO\n";
				ai.getNetwork().printDebugStatus();
				std::cout << "\n";
			}
			else if(c == 'f')
				std::cout << "\n\nCurrent Fitness = " << ai.getNetwork().getLocalFitness() << "\n";
			else if(c == 'u')
			{
				std::cout << "\n";
				U.print();
				EL.print();
			}
		}
		mainLoop();
	}
}