/*
UID.h
Written by Walter O. Krawec

Copyright (c) 2012 Walter O. Krawec

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef WOK_UID_H
#define WOK_UID_H

namespace wok
{
	class UID
	{
	public:
		class Manager
		{
		public:
			Manager() : nextID(0) {};
			static Manager& instance()
			{
				static Manager manager;
				return manager;
			};
			
			unsigned int getNewID()
			{
				++nextID;
				return nextID;
			}
			
			void setNext(unsigned int _nextID)
			{
				nextID = _nextID;
			}
			
		private:
			unsigned int nextID;
		};
		
		UID()
		{
			ID = Manager::instance().getNewID();
		};
			
		unsigned int get() const
		{
			return ID;
		};
			
		void set(unsigned int value)
		{
			ID = value;
		};
			
		bool operator==(const UID& otherID) const
		{
			if(ID == otherID.ID)
				return true;
			return false;
		}
			
			
	private:
		unsigned int ID;
	};
};

#endif